// Burning Point t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

unsigned char buff[0x100*16*80];
unsigned char adpcm[0x40000];		// ADPCM؂op
static unsigned char dir[0x700];	// fBNg[hp
static char dirpath[FILENAME_MAX];	// 쐬fBNg

D88 disk;
FILE *fp;
int numdisk;

// ̃fBXNʒũt@C؂o
bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size, bool _sw) {
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	if (_sw) printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int aload(int _trk, int _sec, int _size, int _adr) {
	int size = 0;
	size = disk.ReadDATA(_trk, _trk>>1, _trk&1, _sec, 0x01, &adpcm[_adr], _size);
	if (size != _size) {
		printf("read error = %04x\n",_adr);
		return 0;
	}
	else return size;
}

bool asave(char *_fname, int _adr, int _size) {
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&adpcm[_adr], 1, _size, fp);
	fclose(fp);
	return true;
}

// fBNgGg̃[h
bool dirload(void) {

	bool dirflag = false;
	int diskno;

	for (diskno = 0; diskno<numdisk; diskno++) {
		memset(buff, 0x00, sizeof(buff));
		disk.SelectDisk(diskno); 

		// fBXN
		disk.ReadDATA(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		int id = buff[0x00]*0x100 + buff[0x01];
		
		// Disk No.3At@Ce[u[h
		if (id == 0x7600) {
			dirflag = true;
			disk.ReadDATA(0x00, 0x00, 0x00, 0x02, 0x01, dir, sizeof(dir));
			break;
		}
	}
	return dirflag;
}

int main(int argc, char *argv[]) {

	char fname[FILENAME_MAX];
	int mode=0;
	int dsk, trk, sec, secnum;
	int diskid;
	int size;

	if (argc<2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file][-d]\n",argv[0]);
		return 1;
	}

	if (argc>2) {
		if (!strcmp(argv[2],"-d")) mode=1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	numdisk = disk.GetNumDisk();
	disk.SetRecordRange(0x01,0x10);

	// fBNg̃[h
	if (!dirload()) {
		fprintf(stderr, "Disk No.3܂.\nDisk No.1`No.5AꂽC[WgpĂ.\n");
		return 2;
	}

	// fBXN̐؂o
	for (int diskno = 0; diskno<numdisk; diskno++) {
		memset(buff, 0x00, sizeof(buff));
		disk.SelectDisk(diskno); 
		// fBXN
		diskid = -1;
		disk.ReadDATA(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);

		switch (buff[0x00]*0x100+buff[0x01]) {
			case 0x1803:
				printf("\nDisk No.1 F܂.\n");
				diskid = 99;
				break;
			case 0x7601:
				printf("\nDisk No.2 F܂.\n");
				diskid = 1;
				break;
			case 0x7600:
				printf("\nDisk No.3 F܂.\n");
				diskid = 0;
				break;
			case 0x7602:
				printf("\nDisk No.4 F܂.\n");
				diskid = 2;
				break;
			case 0x7603:
				printf("\nDisk No.5 F܂.\n");
				diskid = 3;
				break;
		}

		// o̓fBNg̍쐬
		if (mode) {
			sprintf(dirpath,"%03d",diskid);		// fBNg̐
		}
		else {
			sprintf(dirpath,"000");
		}
		_mkdir(dirpath);
		_chdir(dirpath);
		printf("[%s] -> %s\n",disk.GetDiskName(),dirpath);

		// Disk No.1̂Ƃ̏
		if (diskid == 99) {
			// hCo/ADPCMf[^̐؂o
			fcut("MUCO3",  0x06, 0x03, 0x00, 0x0b, 0x01, 0x0000, 0x01200, true);
			fcut("PCMLDR", 0x07, 0x03, 0x01, 0x0d, 0x01, 0x0000, 0x00200, true);
			for (int i=0; i<0x20; i++) {
				aload(0x08+i*2, 0x01, 0x2000, 0x1fe0*i);
			}
			asave("ADPCM", 0, 0x1fe0*0x1f+0x2000);

			_chdir("..");
			continue;
		}

		// t@C̐؂o
		for (int i=0; i<0x700/4; i++) {
			dsk    = dir[i*4  ];
			trk    = dir[i*4+1];
			sec    = dir[i*4+2];
			secnum = dir[i*4+3];

			if (dsk == diskid) {
				sprintf(fname,"B%03X_%d", i, dsk);		// o̓t@C
				// fBXNԍ̈vt@C؂o
				printf("%s : DSK=%02d TRK=%02d SEC=%02d SECNUM=%02d\n", fname, dsk, trk, sec, secnum);
				fcut(fname, trk, trk>>1, trk&1, sec, 0x01, 0x0000, secnum*0x100, false);
			}
		}

		_chdir("..");	// efBNg
	}

	return 0;
}

